// file: dec_pos_0.cc
//

// system include files
//
#include <string.h>

#include "decoder.h"
#include "decoder_constants.h"
 
// method: compute_posterior_cc
//
// arguments:
//  FILE* fp: (input) file pointer to write the lattice to
//
// return: a logical_1 indicating status
//
// this method computes posterior for every link and writes it into the new
// lattice
//
logical_1 Decoder::compute_posterior_cc(FILE* fpi_a, FILE* fpo_a) {

  // check file
  //
  if (fpi_a == (FILE*)NULL) {
    error_handler_cc((char_1*)"read_lattice_cc",
		     (char_1*)"NULL input file pointer");
  }
  
  // initialize lattice if not done so
  //
  if (lattice_d == (Lattice*)NULL) {
    lattice_d = new Lattice();
  }

  // read the lattice from file
  //
  lattice_d->compute_posterior_cc(fpi_a, lexicon_d);
  
  lattice_d->write_lattice_cc(fpo_a, ISIP_FALSE, ISIP_FALSE, ISIP_FALSE);

  // free memory
  //
  //delete lattice_d;
  //lattice_d = (Lattice*)NULL;
  
  // exit gracefully
  //
  return ISIP_TRUE;
}
