// file: dtn_cstr_1.cc
//

// isip include files
//
#include "dt_node.h"
#include "dt_node_constants.h"

// method: constructor
//
// arguments: none
//
// return: none
//
// this is the default constructor
//
Dt_node::Dt_node() {

  // set the parent and children informaiton
  //
  parent_d =  (Dt_node*)NULL;
  l_child_d = (Dt_node*)NULL;
  r_child_d = (Dt_node*)NULL;

  // initialize the optimal question
  //
  opt_question_d = (Question*)NULL;
  
  // initialize the state indices at this node
  //
  num_states_d = 0;
  state_index_d = (int_4*)NULL;
  
  // initialize the likelihood information
  //
  likelihood_d = (float_4)0;
  split_lk_inc_d = (float_4)0;
  
  // set the label value
  //  
  label_d = (int_4)0;
  
  // set the flag value
  //
  flag_leaf_d = ISIP_TRUE ;
  flag_visit_d = ISIP_FALSE;
  
  // exit gracefully
  //
}
