// file: $PDSP/class/fourier_transform/v3.0/ft_set_5.cc
//

// isip include files
//
#include "fourier_transform.h"
#include "fourier_transform_constants.h"

// method: set_cc (overloaded)
//
// arguments:
//  int_4 order_a: (input) order of the transform
//  char_1* name_a: (input) corresponds to name of the algorithm to be tested
//  int_4 type_a: (input) type of data ( real/complex )
//
// return: a logical_1 value indicating status
//
// this method sets the parameters which are provided by the used
// from the command line
//
logical_1 Fourier_transform::set_cc(int_4 order_a,
					     char_1* name_a,
					     int_4 type_a) {
  // set the parameters
  //
  N_d = order_a;
  data_type_d = type_a;
  
  // check the algorithm
  //
  algorithm_d = set_cc(name_a);

  // exit gracefully 
  //
  if (algorithm_d < (int_4)0) {
    return ISIP_FALSE;
  }
  else {
    return ISIP_TRUE;
  }
}

