// file: inst_clear_1.cc
//

// isip include files
//
#include "instance.h"
#include "instance_constants.h"

// method: prune_cc
//
// arguments:
//  logical_1 flag: (input) alignment mode flag
//  int_4& ndel: (output) number of deleted traces
//
// return: a logical_1 flag indicating status
//
// this method prunes away all the traces in this instance
//
logical_1 Instance::prune_cc(logical_1 flag_a, int_4& ndel_a) {

  // reset the best score
  //
  max_score_d = INSTANCE_DEFAULT_SCORE;
  
  // make sure the token list exists
  //
  if (token_list_d == (Link_list*)NULL) {
    return ISIP_TRUE;
  }

  // dummy variables
  //
  Token* tok = (Token*)NULL;

  // loop over all active tokens --- each corresponds to an
  // active state for this phone
  //
  for (Link_node* tok_node = token_list_d->get_head_cc();
       tok_node != (Link_node*)NULL; tok_node = tok_node->get_next_cc()) {
    
    // get the corresponding token
    //
    tok = (Token*)(tok_node->get_item_cc());
    
    // prune the traces in this token
    //
    tok->prune_all_cc(flag_a, ndel_a);
    
  } // end loop over all tokens

  // exit gracefully
  //
  return ISIP_TRUE;
}
