// file: lat_cstr_2.cc
//

// isip include files
//
#include "lattice.h"
#include "lattice_constants.h"

// method: constructor
//
// arguments:
//  int_4 num_nodes: (input) number of lattice nodes
//  int_4 num_arcs: (input) number of lattice arcs
//  Hash_table* lnodes: (input) Hash table of lattice nodes
//
// return: none
//
// this is an overloaded constructor
//
Lattice::Lattice(int_4 num_nodes_a, int_4 num_arcs_a, Hash_table* lnodes_a) {

  // set node statistics
  //
  num_arcs_d = num_arcs_a;
  num_nodes_d = num_nodes_d;

  // set node pointers
  //
  lnode_d = lnodes_a;
  start_node_d = (Lattice_node*)NULL;

  // set lattice generation infrmation
  //
  lang_model_d = (char_1*)NULL;
  utterance_d = (char_1*)NULL;
  model_set_d = (char_1*)NULL;
  name_d = (char_1*)NULL;
  null_word_d = (Word*)NULL;
  
  // set likelihood scale factors
  //
  lm_scale_d = LATTICE_DEFAULT_SCALE;
  word_penalty_d = LATTICE_DEFAULT_PENALTY;
  
  // exit gracefully
  //
}
