// file: latn_add_10.cc
//

// isip include files
//
#include "lattice_node.h"
#include "lattice_node_constants.h"

// method: replace_posterior_cc
//
// arguments:
//  float_4 posterior_score: (input) new posterior score which replaces old posterior score
//  int_4 index: position of the posterior score in the array
//
// return: logical_1 indicating status
//
// this method replaces the existing posterior score with a new posterior score
//
logical_1 Lattice_node:: replace_posterior_cc(float_4 posterior_a,
					      int_4 index_a) {
  
  // replace the old value by the new value
  //
  for (int_4 i = 0; i < num_arcs_out_d; i++) {
    
    if (i == index_a) {
      posterior_d[i] = posterior_a;
    }
  }
  
  // exit gracefully
  //
  return ISIP_TRUE;
}
