// file: latn_add_7.cc
//

// isip include files
//
#include "lattice_node.h"
#include "lattice_node_constants.h"

// method: add_node_index_cc
//
// arguments:
//  int_4 node_index: (input) index to be added
//
// return: logical_1 indicating status
//
// this method appends the next node index to the current array
//
logical_1 Lattice_node::add_next_node_index_cc(int_4 next_node_index_a) {
  
  // define a temporary array
  //
  int_4* new_list = new int_4[num_arcs_out_d];
  
  // check if the num_arcs_out array exists
  //
  if ((num_arcs_out_d > 1) && (next_node_index_d != (int_4*)NULL)) {
    
    // copy old data to new array
    //
    memcpy(new_list, next_node_index_d, (num_arcs_out_d - 1) * sizeof(float_4));
  }
  
  // add the new value to the next available spot in the array
  //
  new_list[(num_arcs_out_d - 1)] = next_node_index_a;
  
  // free old memory and reset pointers
  //
  if (next_node_index_d != (int_4*)NULL) {
    delete [] next_node_index_d;
    next_node_index_d = (int_4*)NULL;
  }
  next_node_index_d = new_list;    
  
  // exit gracefully
  //
  return ISIP_TRUE;
}
