// file: latn_add_8.cc
//

// isip include files
//
#include "lattice_node.h"
#include "lattice_node_constants.h"

// method: add_prev_node_index_cc
//
// arguments:
//  int_4 node_index: (input) previous node index to be added
//
// return: logical_1 indicating status
//
// this method appends the previous node index array with the new value
//
logical_1 Lattice_node::add_prev_node_index_cc(int_4 prev_node_index_a) {
  
  // define a temporary array
  //
  int_4* new_list = new int_4[num_arcs_in_d];
  //int_4 array_size = 0;
  
  // check if the num_arcs_in array exists
  //
  if ((num_arcs_in_d > 1) && (prev_node_index_d != (int_4*)NULL)) {

    memcpy(new_list, prev_node_index_d, (num_arcs_in_d - 1) * sizeof(float_4));

    /**  
    // copy old data to new array
    //
    for (int_4 i = 0; i < num_arcs_in_d ; i++) {
      if (prev_node_index_d[i] != prev_node_index_a) {
	memcpy(new_list, prev_node_index_d, (i+1) * sizeof(float_4));
	array_size = i+1;
	break;
      }
    }**/
  }
  
  // add the new value to the next available spot in the array
  //
  new_list[(num_arcs_in_d - 1)] = prev_node_index_a;
  
  // free old memory and reset pointers
  //
  if (prev_node_index_d != (int_4*)NULL) {
    delete [] prev_node_index_d;
    prev_node_index_d = (int_4*)NULL;
  }
  prev_node_index_d = new_list;    
  
  // exit gracefully
  //
  return ISIP_TRUE;
}
