// file: latn_set_9.cc
//

// isip include files
//
#include "lattice_node.h"
#include "lattice_node_constants.h"

// method: add_gamma_cc
//
// arguments:
//  float_4 gamma_a: (input) gamma
//
// return: a logical_1 indicating status
//
// this method sets the arc gamma
//
logical_1 Lattice_node::add_gamma_cc(float_4 gamma_a, int_4 node_id_a) {
  /***
  // define a temporary array
  //
  float_4* new_list = new float_4[num_arcs_out_d];
  int_4 array_size = 0;
  
  
  
  // check if the posterior array exists
  //
  if ((num_arcs_out_d > 1) && (posterior_d != (float_4*)NULL)) {
    
    // copy old data to new array
    //
    for (int_4 i = 0; i < num_arcs_out_d ; i++) {
      if (posterior_d[i] != posterior_a) {
      memcpy(new_list, posterior_d, (i+1) * sizeof(float_4));
	array_size = i+1;
	break;
      }
    }
  }
  
  // add the new value to the next available spot in the array
  //
  new_list[(array_size)] = posterior_a;
  
  // free old memory and reset pointers
  //
  if (posterior_d != (float_4*)NULL) {
    delete [] posterior_d;
    posterior_d = (float_4*)NULL;
  }
  posterior_d = new_list;    
***/

  // define a temporary array
  //
  float_4* new_list = new float_4[num_arcs_out_d];

  // check if the gamma array exists
  //
  if ((num_arcs_out_d > 1) && (gamma_d != (float_4*)NULL)) {
    memcpy(new_list, gamma_d, (num_arcs_out_d) * sizeof(float_4));
  }

  // add the new value to the next available spot in the array
  //
  new_list[node_id_a] = gamma_a;
  
  // free old memory and reset pointers
  //
  if (gamma_d != (float_4*)NULL) {
    delete [] gamma_d;
    gamma_d = (float_4*)NULL;
  }
  gamma_d = new_list;
  
  // exit gracefully
  //
  return ISIP_TRUE;
}
