// file: latn_cstr_4.cc
//

// isip include files
//
#include "lattice_node.h"
#include "lattice_node_constants.h"

#include <lex_tree.h>
#include <lex_tree_constants.h>

// method: default constructor
//
// arguments:
//  float_4 alpha,
//  float_4* posterior,
//  int_4* next_node_index,
//  int_4* prev_node_index
//
// return: none
//
// this is an overloaded constructor for the confidence estimation
//
Lattice_node::Lattice_node(float_4 alpha_a,
			   float_4 beta_a,
			   float_4* gamma_a,
			   int_4* next_node_index_a,
			   int_4* prev_node_index_a) {
  
  // set node identity
  //
  type_d = LATTICE_NODE_DEFAULT_TYPE;
  word_d = (Word*)NULL;
  pron_variant_d = LATTICE_NODE_DEFAULT_PRON_VAR;
  frame_d = LATTICE_NODE_DEFAULT_FRAME;
  node_index_d = LATTICE_NODE_DEFAULT_INDEX;
  num_arcs_in_d = LATTICE_NODE_DEFAULT_NUM_ARCS_IN;
  num_arcs_out_d = LATTICE_NODE_DEFAULT_NUM_ARCS_OUT;
  
  // set node pointers
  //
  prev_nodes_d = (Link_list*)NULL;
  next_nodes_d = (Link_list*)NULL;
  
  // set the lexical tree
  //
  lex_tree_d = (Lex_tree*)NULL;

  // set the lm and ac scores array
  //
  lm_scores_d = (float_4*)NULL;
  ac_scores_d = (float_4*)NULL;
  
  // set the alpha, beta and posterior values
  alpha_a = (float_4)0;
  beta_a = (float_4)0;
  gamma_a = (float_4*)NULL;
  next_node_index_a = (int_4*)NULL;
  prev_node_index_a = (int_4*)NULL;
  
  // exit gracefully
  //
}
