// file: lxt_debug_0.cc
//
 
// isip include files
//
#include "lex_tree.h"
#include "lex_tree_constants.h"

// method: debug_cc
//
// arguments:
//  FILE* fp: (input) file pointer used for output
//  char_1* message: (input) a message concatenated to each debug message
//
// return: a logical_1 value indicating status
//
// this method displays the values of all internal data
//
logical_1 Lex_tree::debug_cc(FILE* fp_a, char_1* message_a) {

  // dump the word-history information
  //
  fprintf(fp_a, "%s::%s: history_d = %p\n", LXT_CLASS_NAME, message_a,
	  history_d);

  // dump the lexical tree nodes starting from the head
  //
  fprintf(fp_a, "%s::%s: head_d = %p\n", LXT_CLASS_NAME, message_a,
	  head_d);

  // output the status information
  //
  fprintf(fp_a, "%s::%s: status_d = %c\n", LXT_CLASS_NAME, message_a,
	  status_d);
  
  // exit gracefully
  //
  return ISIP_TRUE;
}
