// file: mm_new_4.cc
//
 
// isip include files
//
#include "memory_manager.h"
#include "memory_manager_constants.h"

#include <hash_cell.h>

// method: new_hash_cc
//
// arguments: none
//
// return: a Hash_cell* pointer to a new hash table cell
//
// this method outputs a new empty hash table cell, and creates them
// whenever necessary
//
Hash_cell* Memory_manager::new_hash_cc() {

  // if there are no free hash table cells available, create a few
  //
  if (hash_count_d == (int_4)0) {
    grow_hash_cc();
  }
  
  // get a hash table cell off the list
  //
  Link_node* lnd = hash_list_d;
  hash_list_d = hash_list_d->get_next_cc();
  
  // adjust params
  //
  lnd->set_next_cc((Link_node*)NULL);
  if (hash_list_d != (Link_node*)NULL) {
    hash_list_d->set_prev_cc((Link_node*)NULL);
  }

  // get the hash table cell here
  //
  Hash_cell* hcell = (Hash_cell*)(lnd->get_item_cc());
  
  // return the link node to the free node list
  //
  delete_cc(lnd);

  // decrement free hash table cell count
  //
  hash_count_d --;
  
  // return the hash table cell and exit gracefully
  //
  return hcell;
}
