// file: pfil_get_5.cc
//

// system include files
//
#include <stdlib.h>
#include <string.h>

// isip include files
//
#include "param_file.h"
#include "param_file_constants.h"
#include <integral_constants.h>

// method: get_cc
//
// arguments:
//  float_4 &value: (output) value of the parameter
//  char_1* param: (input) parameter to return
//
// return: a logical_1 indicating status
//
// this method get the value of parameter
//
logical_1 Param_file::get_cc(float_4& value_a, char_1* param_a) {
  
  // check arguments
  //
  if (param_a == (char_1*)NULL) {
    error_handler_cc((char_1*)"get_cc",
		     (char_1*)"input string is null");
  }

  // loop until param_a = params_d[i], return values_d[i];
  //
  for (int_4 i=0; i < num_params_d; i++) {
    if (strcmp((char*)param_a, (char*)params_d[i]) == 0) {
      return convert_string_cc(value_a, values_d[i]);
    }
  }
  
  // exit ungracefully if parameter not found
  //
  return ISIP_FALSE;  
}
