// file: phn_debug_0.cc
//
 
// isip include files
//
#include "phone.h"
#include "phone_constants.h"

// method: debug_cc
//
// arguments:
//  FILE* fp: (input) file pointer used for output
//  char_1* message: (input) a message concatenated to each debug message
//
// return: a logical_1 value indicating status
//
// this method displays the values of all internal data
//
logical_1 Phone::debug_cc(FILE* fp_a, char_1* message_a) {

  // dump the name and number of constituent monophones
  //
  fprintf(fp_a, "%s::%s: name_d = %s\n", PHN_CLASS_NAME, message_a, name_d);
  fprintf(fp_a, "%s::%s: num_phones_d = %ld\n", PHN_CLASS_NAME, message_a,
	  num_phones_d);

  // output the monophones
  //
  fprintf(fp_a, "%s::%s: phones_d = %p\n", PHN_CLASS_NAME, message_a,
	  phones_d);
  for (int_4 i = 0; i < num_phones_d; i++) {
    fprintf(fp_a, "%s::%s: phones_d[%ld] = %ld\n", PHN_CLASS_NAME,
	    message_a, i, phones_d[i]);
  }

  // output the model
  //
  fprintf(fp_a, "%s::%s: model_d = %p\n", PHN_CLASS_NAME, message_a,
	  model_d);
  if (model_d != (Model*)NULL) {
    model_d->debug_cc(fp_a, message_a);
  }
  
  // exit gracefully
  //
  return ISIP_TRUE;
}
