// file: tp_load_0.cc
//
// function to load the acustic model related data into the decoder
//

// isip include files
//
#include "trace_projector.h"
#include "trace_projector_constants.h"

// method: load_ac_models_cc
//
// arguments: none
//
// return: a logical flag to indicate status
//
// this method loads the acoustic models
//
logical_1 Trace_projector::load_ac_models_cc() {
			    
  // temporary file pointer
  //
  FILE* fp = (FILE*)NULL;

  // load the transitions
  //
  open_file_cc(fp, transitions_file_d, (char_1*)"r");
  decoder_d->read_transitions_cc(fp);
  fclose(fp);

  // load the hmm states
  //
  open_file_cc(fp, states_file_d, (char_1*)"rb");
  decoder_d->read_states_cc(fp);
  fclose(fp);

  // load the base hmm models
  //
  open_file_cc(fp, models_file_d, (char_1*)"r");
  decoder_d->read_hmms_cc(fp);
  fclose(fp);
  
  // load the context dependent models
  //
  open_file_cc(fp, phones_file_d, (char_1*)"r");
  decoder_d->read_cd_models_cc(fp);
  fclose(fp);

  // return gracefully
  //
  return ISIP_TRUE;
}
