// file: tr_lat_debug_0.cc
//

// isip include files
//
#include "train_lattice.h"
#include "train_lattice_constants.h"

// method: debug_cc
//
// arguments:
//  FILE* fp: (input) a open file pointer
//  char_1* message: (input) a message to be displayed
//
// return: a logical_1 flag indicating success
//
logical_1 Train_Lattice::debug_cc(FILE *fp_a, char_1* message_a) {
  
  // dump the contents of the class to the file
  //
  fprintf(fp_a, "%s::%s num_arcs_d = %ld\n", TRAIN_LATTICE_CLASS_NAME, message_a,
	  num_arcs_d);
  fprintf(fp_a, "%s::%s num_nodes_d = %ld\n", TRAIN_LATTICE_CLASS_NAME, message_a,
	  num_nodes_d);
  
  fprintf(fp_a, "%s::%s lm_scale_d = %f\n", TRAIN_LATTICE_CLASS_NAME, message_a,
	  lm_scale_d);
  fprintf(fp_a, "%s::%s word_penalty_d = %f\n", TRAIN_LATTICE_CLASS_NAME, message_a,
	  word_penalty_d);
  
  fprintf(fp_a, "%s::%s land_Train_Model_d = %s\n", TRAIN_LATTICE_CLASS_NAME, message_a,
	  lang_model_d);
  fprintf(fp_a, "%s::%s utterance_d = %s\n", TRAIN_LATTICE_CLASS_NAME, message_a,
	  utterance_d);
  fprintf(fp_a, "%s::%s model_set_d = %s\n", TRAIN_LATTICE_CLASS_NAME, message_a,
	  model_set_d);
  
  fprintf(fp_a, "%s::%s lnode_d = %p\n", TRAIN_LATTICE_CLASS_NAME, message_a,
	  lnode_d);
  fprintf(fp_a, "%s::%s start_node_d = %p\n", TRAIN_LATTICE_CLASS_NAME, message_a,
	  start_node_d);

  // exit gracefully
  //
  return ISIP_TRUE;
}
