// file: train_phone.h
//

// this is the header for the train_phone class
//

// make sure definitions are only made once
//
#ifndef __ISIP_TRAIN_PHONE
#define __ISIP_TRAIN_PHONE

// isip include files
//
#ifndef __ISIP_INTEGRAL
#include <integral.h>
#endif

// forward class definitions
//
#ifndef __ISIP_TRAIN_MODEL
#include <train_model.h>
#endif

// Train_Phone: a class that contains a phone name and its model data
//
class Train_Phone {
  
  //---------------------------------------------------------------------------
  //
  // protected data
  //
  //---------------------------------------------------------------------------
protected:
  
  // the name of the phone
  //
  char_1* name_d;

  // the indices of the constituent phones
  //
  int_4 num_phones_d;
  int_4* phones_d;
  
  // parameters related to the phone model
  //
  Train_Model* model_d;

  // flag to indicate if this is active
  //
  logical_1 active_d;
  
  //---------------------------------------------------------------------------
  //
  // public methods
  //
  //---------------------------------------------------------------------------
public:

  // required methods
  //
  char_1* name_cc();
  volatile void error_handler_cc(char_1* method_name, char_1* message);
  logical_1 debug_cc(FILE* fp, char_1* message);
  int_4 size_cc();
  
  // destructors/constructors
  //
  ~Train_Phone();  
  Train_Phone();
  Train_Phone(char_1* name, int_4 nph, int_4* phones, Train_Model* model);
  Train_Phone(const Train_Phone &phone);

  // set methods
  //
  logical_1 set_name_cc(char_1* name);
  logical_1 set_model_cc(Train_Model* model);
  logical_1 set_active_cc(logical_1 val);
  
  // get methods
  //
  char_1* get_name_cc();
  Train_Model* get_model_cc();
  logical_1 get_active_cc();

  // phone methods
  //
  int_4 get_num_phones_cc();
  int_4 get_phone_cc(int_4 ind);
  logical_1 set_phones_cc(int_4 nph, int_4* phones);
  
  //---------------------------------------------------------------------------
  //
  // private methods
  //
  //---------------------------------------------------------------------------
private:

};

// end of file
// 
#endif
