// file: convert_mmf.h
//
 
// make sure this file is only included once
//
#ifndef __ISIP_CONVERT_MMF
#define __ISIP_CONVERT_MMF

// isip include files
//
#ifndef __ISIP_INTEGRAL
#include <integral.h>
#endif

#ifndef __ISIP_TRAIN_STATE
#include <train_state.h>
#endif

// define external functions
//
// define the function to parse the command line
logical_1 get_params_cc(int_4 argc, char_1** argv,
			int_4& input_mode_flag, int_4& output_mode_flag,
			char_1* input_file, char_1* output_file);

// define read functions
//
Train_State** read_states_cc(int_4 read_mode, int_4& num_st, int_4& num_feat,
			     char_1* file);
Train_State** read_states_ascii_cc(int_4& num_st, int_4& num_feat,
				   char_1* file);
Train_State** read_states_bin_cc(int_4& num_st, int_4& num_feat, char_1* file);
  

// define write functions
//
logical_1 write_states_cc(int_4 write_mode, int_4 num_st, int_4 num_feat,
			  char_1* st_file, Train_State** state_list);
logical_1 write_states_ascii_cc(int_4 num_st, int_4 num_feat,
				char_1* st_file, Train_State** state_list);
logical_1 write_states_bin_cc(int_4 num_st, int_4 num_feat,
			      char_1* st_file, Train_State** state_list);
  
// end of file
//
#endif
