// file: init_triphones_constants.h
//
// definitions file for the trace projetion decoder
//

// make sure definitions are made only once
//
#ifndef __ISIP_INIT_TRIPHONES_CONSTANTS
#define __ISIP_INIT_TRIPHONES_CONSTANTS

// isip include files
//  
#ifndef __ISIP_INTEGRAL_CONSTANTS
#include <integral_constants.h>
#endif

// forward declaration of classes
//
#ifndef __ISIP_TRAIN_STATE_CONSTANTS
#include <train_state_constants.h>
#endif

#ifndef __ISIP_TRAIN_MODEL_CONSTANTS
#include <train_model_constants.h>
#endif

#ifndef __ISIP_TRAIN_HASH_TABLE_CONSTANTS
#include <train_hash_table_constants.h>
#endif

// define the help file
//
#define ITRI_HELP_FILE (char_1*)"$ISIP_PROTO/doc/init_triphones.help"

// commandline identifiers
//
#define ITRI_PARAM_OPT "-param"
#define ITRI_HELP_OPT "-help"

// parameter file field identifiers
//
#define ITRI_IN_MODELS (char_1*)"in_models_file"
#define ITRI_OUT_MODELS (char_1*)"out_models_file"
#define ITRI_IN_TRANS (char_1*)"in_trans_file"
#define ITRI_OUT_TRANS (char_1*)"out_trans_file"
#define ITRI_IN_STATES (char_1*)"in_states_file"
#define ITRI_OUT_STATES (char_1*)"out_states_file"
#define ITRI_TRI_CLIST (char_1*)"tri_clist_file"
#define ITRI_CI_PHONES (char_1*)"ci_phones_file"

// characters used to trigger filename expansion via a system call ---
// since this is expensive, we only want to do it when it is
// absolutely necessary
//
#define ITRI_ENV_DELIMITERS (char_1*)"$~(){}[]?"

// define some phyiscal limits on tasks handled
//
#define ITRI_MAX_NUM_MODELS (long)99999
#define ITRI_MAX_NUM_STATES (long)999999

// define the constant string
//
#define ITRI_STR_NUM_TRANSITIONS "num_transitions"
#define ITRI_STR_NUM_MODELS "num_models"
#define ITRI_STR_NUM_MONOPHONES "num_monophones"
#define ITRI_SP_PHONE (char*)"sp"
#define ITRI_SIL_PHONE (char*)"sil"

// end of file
//
#endif





