#! /usr/local/bin/wish -f
#
# File: isip_decoder_demo.tcl
#

# This file calls the functions and runs the demo for the 
# N-best word hypotheses of the trace-projection Viterbi decoder
#

# set the GUI library routine directory
#
set ISIP_TOKP_HOME "$env(ISIP_PROTO)/lib/scripts/tcl/isip_decoder_demo"

# source the globals
#
source $ISIP_TOKP_HOME/src/dec_globals.tcl

# source the display for the GUI
#
source $ISIP_TOKP_HOME/src/dec_display.tcl

# source procedures to read data
#
source $ISIP_TOKP_HOME/src/dec_env.tcl
source $ISIP_TOKP_HOME/src/dec_config.tcl
source $ISIP_TOKP_HOME/src/dec_read_0.tcl
source $ISIP_TOKP_HOME/src/dec_write_0.tcl
source $ISIP_TOKP_HOME/src/dec_file_0.tcl
source $ISIP_TOKP_HOME/src/dec_filesel.tcl

# procedures to advance the demo
#
source $ISIP_TOKP_HOME/src/dec_next_0.tcl
source $ISIP_TOKP_HOME/src/dec_reset.tcl

# procedures to draw the hypothesis graph
#
source $ISIP_TOKP_HOME/src/dec_plot_0.tcl
source $ISIP_TOKP_HOME/src/dec_plot_1.tcl
source $ISIP_TOKP_HOME/src/dec_plot_2.tcl
source $ISIP_TOKP_HOME/src/dec_plot_3.tcl

# shut down and exit procedures
#
source $ISIP_TOKP_HOME/src/dec_quit_0.tcl

# end of file
#
