// file: tp_cmd_0.cc
//

// isip include files
//
#include "trace_projection.h"

// forward declaration of classes
//
#ifndef __ISIP_DECODER
#include <decoder.h>
#endif

// method: read_cmdline_cc
//
// arguments:
//  int_4 argc : (input) number of arguments
//  char_1** argv : (input) argument variables
//  char_1*& prm_file : (output) name of the parameters file
//  logical_1& demo : (output) if this is demo mode
//
// return: a logical_1 flag indicating success
//
// this method reads the commandline and deciphers the various
// arguments and options
//
logical_1 read_cmdline_cc(int_4 argc_a, char_1** argv_a, char_1*& prm_file_a,
			  logical_1& demo_a) {

  // create the help message
  //
  char_1* cmd_str = new char_1[ISIP_MAX_STRING_LENGTH];
  sprintf((char*)cmd_str, (char*)ISIP_HELP_FORMAT, (char*)TP_HELP_FILE);

  // check if the help message needs to be printed
  //
  if (argc_a < 3) {
    
    // print the help message and exit
    //
    system((char*)cmd_str);
    exit(ISIP_PROTO_ERROR);
  }
  
  // decipher the commandline arguments
  //
  for (int_4 i = 1; i < argc_a; i++) {
    
    // read the name of the parameter file
    //
    if (strcmp(TP_PARAMS_OPT, (char*)argv_a[i]) == 0) {
      prm_file_a = new char_1[ISIP_MAX_STRING_LENGTH];
      strcpy((char*)prm_file_a, (char*)argv_a[++i]);
      Decoder::expand_filename_cc(prm_file_a);
    }
    
    // set the demo flag if specified
    //
    else if (strcmp(TP_DEMO_OPT, (char*)argv_a[i]) == 0) {
      demo_a = ISIP_TRUE;
    }
    
    // otherwise print the help message and exit
    //
    else {      
      system((char*)cmd_str);
      exit(ISIP_PROTO_ERROR);
    }
  }

  // free memory
  //
  delete [] cmd_str;
  
  // exit gracefully
  //
  return ISIP_TRUE;
}
